// AxStatic.cpp : implementation file
//

#include "stdafx.h"
#include "AxStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAxStatic
namespace AxWinLib {

CAxStatic::CAxStatic() :
	m_dwExStyle(0), 
	m_clFontColor(::GetSysColor(COLOR_WINDOWTEXT)),
	m_lFontSize(0),
	m_bIsDefColor(true),
	m_hCursor(::LoadCursor(0, MAKEINTRESOURCE(IDC_ARROW)))
{
}
//------------------------------------------------------------------------
CAxStatic::~CAxStatic()
{
}
//------------------------------------------------------------------------

BEGIN_MESSAGE_MAP(CAxStatic, CStatic)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_KEYUP()
	ON_WM_SETCURSOR()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAxStatic message handlers

void CAxStatic::OnPaint() 
{
	if (m_bIsDefColor)
		m_clFontColor = ::GetSysColor(COLOR_WINDOWTEXT);

	CPaintDC dc(this); // device context for painting
	dc.SetTextColor(m_clFontColor);
	CFont* pFont  = GetFont();
	if (pFont)
	{
		LOGFONT lf;
		::memset(&lf, 0, sizeof(lf));
		pFont->GetLogFont(&lf);
		lf.lfWeight    = (m_dwExStyle & EX_BOLD) ? 700 : 400;
		lf.lfItalic    = (m_dwExStyle & EX_ITALIC) ? TRUE : FALSE;
		lf.lfStrikeOut = (m_dwExStyle & EX_STRIKEOUT) ? TRUE : FALSE;
		lf.lfUnderline = (m_dwExStyle & EX_UNDERLINE) ? TRUE : FALSE;
		lf.lfHeight    = (m_lFontSize) ? (-m_lFontSize) : lf.lfHeight;
		if (m_sFontFace.GetLength())
		{
			m_sFontFace = m_sFontFace.Left(31);
			::strcpy(lf.lfFaceName, m_sFontFace);
		}

		PreDrawText(lf);
		CFont newfont;
		newfont.CreateFontIndirect(&lf);
		dc.SelectObject(&newfont);
	}

	CRect rc;
	GetWindowRect(rc);
	ScreenToClient(rc);
	dc.ExtTextOut(0, 0, ETO_CLIPPED | ETO_OPAQUE, rc, Caption, NULL);
}
//------------------------------------------------------------------------

BOOL CAxStatic::OnEraseBkgnd(CDC* pDC) 
{
	RECT rect;
	GetClientRect(&rect);
	pDC->FillSolidRect(&rect, ::GetSysColor(COLOR_BTNFACE));
	return CStatic::OnEraseBkgnd(pDC);
}
//------------------------------------------------------------------------

BOOL CAxStatic::PreTranslateMessage(MSG* pMsg) 
{
	static bool bIsHover = true;
	static bool bIsLeave = true;

	if (pMsg->message == WM_MOUSEHOVER && bIsHover)
	{
		bIsHover = false;
		bIsLeave = true;
		OnMouseHover();
	}

	if (pMsg->message == WM_MOUSELEAVE && bIsLeave)
	{
		bIsHover = true;
		bIsLeave = false;
		OnMouseLeave();
	}

	return CStatic::PreTranslateMessage(pMsg);
}
//------------------------------------------------------------------------

void CAxStatic::PreDrawText(LOGFONT& lf)
{
}
//------------------------------------------------------------------------

void CAxStatic::OnMouseHover()
{
}
//------------------------------------------------------------------------

void CAxStatic::OnMouseLeave()
{
}
//------------------------------------------------------------------------

BOOL CAxStatic::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	::SetCursor(m_hCursor);
	
	return TRUE;
}
//------------------------------------------------------------------------

void AxWinLib::CAxStatic::OnMouseMove(UINT nFlags, CPoint point)
{
	TRACKMOUSEEVENT stevent;
	::memset(&stevent, 0, sizeof(stevent));
	stevent.cbSize      = sizeof(stevent);
	stevent.hwndTrack   = m_hWnd;
	stevent.dwFlags     = TME_HOVER | TME_LEAVE;
	stevent.dwHoverTime = 50;
	_TrackMouseEvent(&stevent);

	CStatic::OnMouseMove(nFlags, point);
}
//------------------------------------------------------------------------

} // namespace AxWinLib {
