#if !defined(AFX_AxStatic_H__C0A19EC1_8201_484C_805F_A9C87B29198B__INCLUDED_)
#define AFX_AxStatic_H__C0A19EC1_8201_484C_805F_A9C87B29198B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AxStatic.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAxStatic window

namespace AxWinLib {
class CAxStatic : public CStatic
{
	CString  m_sFontFace;
	COLORREF m_clFontColor;
	DWORD    m_dwExStyle;
	LONG     m_lFontSize;
	HCURSOR  m_hCursor;

//	Helper meber variables
	bool     m_bIsDefCaption;
	bool     m_bIsDefColor;

// Construction
public:
	CAxStatic();
	
// Attributes
public:
	enum EXSTYLES {EX_BOLD = 2, EX_ITALIC = 4, EX_STRIKEOUT = 8, EX_UNDERLINE = 16 };

	void  SetExStyle(DWORD dwExStyle) 
	{
		m_dwExStyle = dwExStyle;
		Invalidate();
	};

	DWORD GetExStyle() const 
	{
		return m_dwExStyle;
	};

	void SetCaption(const CString& sCaption) 
	{
		SetWindowText(sCaption);
		Invalidate();
	};

	CString GetCaption() const 
	{
		CString sCaption;
		GetWindowText(sCaption);
		return sCaption;
	};

	void SetFontFace(const CString& sFontFace)
	{
		m_sFontFace = sFontFace;
		Invalidate();
	};

	CString GetFontFace() const
	{
		return m_sFontFace;
	};

	COLORREF GetFontColor() const
	{
		return m_clFontColor;
	};

	void SetFontColor(COLORREF clFontColor)
	{
		m_clFontColor = clFontColor;
		m_bIsDefColor = false;
		Invalidate();
	};

	LONG GetFontSize() const
	{
		return m_lFontSize;
	};

	void SetFontSize(LONG lFontSize)
	{
		m_lFontSize = lFontSize;
		Invalidate();
	};

	void SetCursor(HCURSOR hCursor)
	{
		m_hCursor = hCursor;
		Invalidate();
	};

	HCURSOR GetCursor() const
	{
		return m_hCursor;
	};

//	Properties
#if _MSC_VER >= 1200
	__declspec(property(get = GetExStyle, put = SetExStyle)) DWORD ExStyle;
	__declspec(property(get = GetCaption, put = SetCaption)) CString Caption;
	__declspec(property(get = GetFontFace, put = SetFontFace)) CString FontFace;
	__declspec(property(get = GetFontColor, put = SetFontColor)) COLORREF FontColor;
	__declspec(property(get = GetFontSize, put = SetFontSize)) LONG FontSize;
	__declspec(property(get = GetCursor, put = SetCursor)) HCURSOR Cursor;
#endif

//	For override
protected:
	virtual void PreDrawText(LOGFONT& lf);

// Operations
public:
	virtual void OnMouseHover();
	virtual void OnMouseLeave();
	
// Overrides
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);

// Implementation
public:
	virtual ~CAxStatic();
	BOOL OnEraseBkgnd(CDC* pDC);

	// Generated message map functions
protected:
	afx_msg void OnPaint();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);

	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
};

} // namespace AxWinLib
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AxStatic_H__C0A19EC1_8201_484C_805F_A9C87B29198B__INCLUDED_)
